function [x,S,AR_rs,AR_mh]=FUSS(f,InitialState,T,Smin,Smax,deltaStep,TypePrun,Threshold,TYPEDOMAIN)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%% Fast Universal Sampler within GibbS 
%%% with light tails 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%





%Omega=2;
%nakpar=4;
%f=@(x) -nakpar*(x).^2/Omega+log(x.^(2*nakpar-1));

%f=@(x) -x.^2/2;
%T=50000;
%Smin=-1000;
%Smax=1000;
%Smin=0.01;
%Smax=1000;

%deltaStep=0.01;
%TypePrun=1;
%Treshold=100;
%TypePrun=2;
%Treshold=0.99;
%TypePrun=3;
%Treshold=0.9;
%TypePrun=4;
%Treshold=0.01;









logYesNo=1; %%%% evaluate log-proposal

%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%

% if nargin<2
%    Smin=-1000;
%    Smax=1000;
%    deltaStep=0.01;
%   % logYesNo=1;
%    TypePrun=1;
%    T=2000;
%    Treshold=10^(-4);
% elseif nargin<3
%    Smin=-1000;
%    Smax=1000;
%    deltaStep=0.01;
%   % logYesNo=1;
%    TypePrun=1; 
%    Treshold=10^(-4);
% end

%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% initial set of support points
S=Smin:deltaStep:Smax;
%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%
if logYesNo==1
    f_S1=f(S);
    MaxV=max(f_S1);
   %%%%%%%%%%%%%%%%%%%%%%
    f_S=exp(f_S1-MaxV);  %%% we can back to pdf domain already.... maybe better strategies
  %%%%%%%%%%%%%%%%%%%%%%%   
    f_S1=f_S1-MaxV;
  NC=1;
else 
   f_S=f(S);
   NC=sum(f_S/max(f_S)*deltaStep); 
   f_S=(1/NC)*f_S;
   f_S1=log(f_S);
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%% PRUNING
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
switch TypePrun
     %%%%%%%%%%%%%%%%%%%%%%%
    case 0        
%%%%%%%%%%%%%%%%%%%%%%%
    %%%% no pruning %%%%
    disp('no pruning')   
    %%%%%%%%%%%%%%%%%%%%%%%
    case 1  
    %%%%%%%%%%%%%%%%%%%%%%%    
               %%%% P1  %%%%
             [Fsorted,pos]=sort(f_S);
           %%%%%%%
             pos=pos(1:length(S)-Threshold);
             S(pos)=[]; %%% pruning
             f_S1(pos)=[];
            f_S(pos)=[];
    %%%%%%%%%%%%%%%%%%%%%%%        
    case 2 
    %%%%%%%%%%%%%%%%%%%%%%%    
          %%%% P2  %%%%
        pos=find(f_S<=Threshold*max(f_S)); 
            S(pos)=[];  %%% pruning
            f_S1(pos)=[];
            f_S(pos)=[];
    %%%%%%%%%%%%%%%%%%%%%%%
    case 3
    %%%%%%%%%%%%%%%%%%%%%%%
    %%%% P3  %%%%
        LengthBefore=length(S)+1;  
        Laux=[];
        while length(S)<LengthBefore
            %%%
            LengthBefore=length(S);
           %%%
            if mod(length(S),2)~=0
                S(end)=[];
                f_S1(end)=[];
                f_S(end)=[]; 
            end
            c_aux=reshape(f_S,2,length(S)/2)';
            %%%%
            c_aux2=abs(c_aux(:,2)-c_aux(:,1));
             if isempty(Laux)
                Laux(end+1) = max(c_aux2);  
             end
            pos=find(c_aux2<=Threshold*Laux(1));
            pos=2*pos;  
            S(pos)=[];
            f_S1(pos)=[];
            f_S(pos)=[];
        end
            S(1)=[];
            f_S1(1)=[];
            f_S(1)=[];
%%%%%%%%%%%%%%%%%%%%%%%
    case 4 
%%%%%%%%%%%%%%%%%%%%%%%  
       %%%% P4  %%%%%
                    LengthBefore=length(S)+1;
                Laux=[];
                while length(S)<LengthBefore
                    LengthBefore=length(S);          
                     if mod(length(S),2)==0
                        S(end)=[];
                        f_S1(end)=[];
                        f_S(end)=[]; 
                     end
                     c_aux=f_S(1:2:end);
                     c_aux3=S(1:2:end);
                    c_aux2=abs(c_aux(2:end)-c_aux(1:end-1)).*(c_aux3(2:end)-c_aux3(1:end-1));

                     if isempty(Laux)
                        Laux(end+1) = max(c_aux2);  
                     end
                    pos=find(c_aux2<=Threshold*Laux(1));
                    pos=2*pos;  
                    S(pos)=[];
                    f_S1(pos)=[];
                    f_S(pos)=[];
                end
                  
end %%%%%%  END PRUNING  %%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%% additional controls
if TYPEDOMAIN==1 & TypePrun==2 
    S=[0.00001 S];
     f_S1=[(1/NC)*f(0.00001) f_S1];
    f_S=[(1/NC)*f(0.00001)  f_S];
end
%%%%%%%%%%%%%%% additional controls
[dime1,dime2]=size(f_S);
if dime1>dime2
f_S=f_S';
f_S1=f_S1';
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%  END PRUNING  %%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% PROPOSAL CONSTRUCTION !!!
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% PROPOSAL construction central part %%			
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
M=length(S);
Proposal=max([f_S(1:end-1);f_S(2:end)]);
deltaStepNew=S(2:end)-S(1:end-1);
area(2:M)=deltaStepNew.*Proposal;
b(2:M)=log(Proposal);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Build exp-tail pieces (light tails)%%			
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
beta=0; %%% a tempering parameter for robustness (beta=0 no tempering) 
% The tails connect with the end pieces
v(1) = f_S1(1);
v(2) = f_S1(2);
v(3) = f_S1(end-1);
v(4) = f_S1(end);
% Control to avoid numerical problems 
pos = find(v==-Inf);
if isempty(pos) == 0
	v(pos) = -50;
end
% first slope and intercept
m(1) = ( v(2) - v(1) ) / ( S(2) - S(1) );
m(1)= m(1)*(1-beta);
b(1) = v(1) - m(1) * S(1);
% end slope and intercept
m(M+1) = ( v(end) - v(end-1) ) / ( S(end) - S(end-1));
m(M+1)= m(M+1)*(1-beta);
b(M+1) = v(end) - m(M+1) * S(end);
% Control for 'suitable' slopes, to get a proper proposal pdf  
if m(1) <= 0
	m(1) = 0.05;
	b(1) = v(1) - m(1) * S(1);
end
if m(M+1) >= 0
	m(M+1) = -0.05;
	b(M+1) = v(4) - m(M+1) * S(end);
end
area(1)=(1/m(1))*exp(m(1)*S(1)+b(1));
area(M+1)=-(1/m(M+1))*exp(m(M+1)*S(end)+b(M+1));
%%%%%%%%%%%%%%%%%%%%
w=area./sum(area);
%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%% END PROPOSAL CONSTRUCTION
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 pos2=round(M/2);
 %x(1)=S(pos2); %%% STARTING STATE; WITHIN A GIBBS there are better choices
 x(1)=InitialState; %%% STARTING-initial STATE
 count=0;
 count_acc_move=0;
 k=2;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%% START
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 while k<=T+1
%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 piece=mnrnd(1,w)*[1:M+1]';
%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
if piece==1
    %disp('tail 1')
   y=exp(m(1)*S(1)+b(1))*rand(1,1);
   xp=(log(y)-b(1))/m(1); 
elseif piece==M+1
    %disp('tail 2')
      y=exp(m(M+1)*S(end)+b(M+1))-exp(m(M+1)*S(end)+b(M+1))*rand(1,1);
      xp=(log(y)-b(M+1))/m(M+1); 
else
  xp=S(piece-1)+deltaStepNew(piece-1)*rand(1,1);   
  %%% es piece-1 piensalo...por como esta construido deltaStepNew   
end

%if xp>10
%    piece
%    S(piece-1)
%    deltaStepNew(piece-1)
%    xp 
    
    
%    pause
%end
 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
     if k==2 
        fp_prev=Proposal(pos2);
     else
        pos=find(sort([S x(k-1)])==x(k-1));       
        fp_prev=exp(m(pos)*x(k-1)+b(pos));
     end 
     
     pos=find(sort([S xp])==xp);
     fp_now=exp(m(pos)*xp+b(pos));
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%     
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  
    if logYesNo==1
        ft_prev=(1/NC)*exp(f(x(k-1))-MaxV);
        ft_now=(1/NC)*exp(f(xp)-MaxV);
    else
        ft_prev=(1/NC)*f(x(k-1));
        ft_now=(1/NC)*f(xp);
    end
 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%     
 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  
     
    
    u=rand(1,1);
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
    alpha1=ft_now/fp_now;
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
	if u > alpha1 %%% RS TEST
        %%%rejection
        count=count+1; %%% count= all the iterations      
    else %%% accepted then MH TEST 
     %   ACCEPTED but addition MH TEST with proper modified proposal
		q_prev=min([ft_prev, fp_prev]);
		q_now=min([ft_now, fp_now]);
		rho=(ft_now*q_prev)/(ft_prev*q_now);
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  
		alpha2=min([1,rho]);
		  u2=rand(1,1);
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  
		if u2<=alpha2 %% MH test 
			x(k) = xp;
            count_acc_move=count_acc_move+1;
    	else
			x(k) = x(k-1);
        end
       %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        k=k+1; %%% number of states so far in the chain 
        count=count+1;%%% count= all the iterations     
    end
 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%    
 end
 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AR_rs=(T-1)/count;%%%  
AR_mh=(T-1)/count_acc_move;




