clear all
close all
clc
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
typeExamplePDF=2;
%%%%%%%%%%%%%%%%%%%
switch typeExamplePDF
    case 1
            logf=@(x)-x.^2/2; %%% log-target; log-full-conditional; log-posterior
            %%%% DOMAIN DEFINITION AND INITIAL SET OF STARTING POINTS
            TYPEDOMAIN=2; %%% 1: domain [0,inf) %%% 2: domain (-inf,inf)
            %%%%%%%%%%%%%%%%%%%%
            Smin=-20;
            Smax=20;
            deltaStep=0.1;
            %%%%%%%%%%%%%%%%%%%
    case 2
            Omega=1;
            nakpar=2;
            logf=@(x) -nakpar*(x).^2/Omega+log(x.^(2*nakpar-1));  %%% log-target; log-full-conditional; log-posterior
             %%%% DOMAIN DEFINITION AND INITIAL SET OF STARTING POINTS
            TYPEDOMAIN=1; %%% 1: domain [0,inf) %%% 2: domain (-inf,inf)
            %%%%%%%%%%%%%%%%%%%%
            Smin=0.1;
            Smax=20;
            deltaStep=0.1;
            %%%%%%%%%%%%%%%%%%%
end
S_initial=Smin:deltaStep:Smax;
disp(['Initial number of support points = ',num2str(length(S_initial))])
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
T=20000; %%% NUMBER OF DESIRED SAMPLES 
%%%% %%%% %%%% %%%% %%%% %%%% %%%% %%%% %%%% 
%%%%%%%%%%%%%%%%%%%%%%%%
%%% PRUNING parameters
TypePrun=1;
Threshold=40; %%% between [2,length(S_initial)], the number of remaining points is exactly Threshold
%%%% suggestion Threshold> 10
%TypePrun=2;
%Threshold=0.5; %%% in [0,1] examples: 0.01, 0.1, 0.2, 0.9
%TypePrun=3;
%Threshold=0.1; %%% positive number 0.001, 0.01, 0.1, 1 (but could be too big) 
%TypePrun=4;
%Threshold=0.001; %%% positive number 0.001, 0.01, 0.1, 1 (but could be too big) 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
InitialState=1;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[x,S,AR_RS,AR_MH]=FUSS(logf,InitialState,T,Smin,Smax,deltaStep,TypePrun,Threshold,TYPEDOMAIN);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
disp(['Final number of support points = ',num2str(length(S))])
disp(['Number of generated samples = ',num2str(T)])
disp(['Acceptance Rate in RS test = ',num2str(AR_RS)])
%disp('Acceptance Rate in nested MH test')
%disp([num2str(AR_MH)])
%disp(' Note that the two tests have a different statistical nature')
%disp(' In this cas, high AR_MH means that the constructed proposal is close to the target pdf')
hist(x,25)
%%%%%
Aaux=corr([x(1:end-1); x(2:end)]');
disp(['Correlation lag-1 between consecutive states = ',num2str(Aaux(1,2))])

